#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Tabs.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Light_Button.H>
#include <FL/Fl_Radio_Button.H>
#include <FL/Fl_Hold_Browser.H>
#include <FL/Fl_Choice.H>

// ADDED THIS
static void TabsCallback(Fl_Widget *w, void*) {
  Fl_Tabs *ww = (Fl_Tabs*)w;
  printf("TABS CALLBACK FOR %s: CHANGED=%d\n",  ww->value()->label(), ww->changed());
}
static void RadioCallback(Fl_Widget *w, void*) {
  Fl_Radio_Button *ww = (Fl_Radio_Button*)w;
  printf("RADIO CALLBACK FOR %s: VALUE IS %d CHANGED=%d\n", ww->label(), ww->value(), ww->changed());
}
static void LightCallback(Fl_Widget *w, void*) {
  Fl_Light_Button *ww = (Fl_Light_Button*)w;
  printf("LIGHT CALLBACK FOR %s: VALUE IS %d CHANGED=%d\n", ww->label(), ww->value(), ww->changed());
}
static void BrowserCallback(Fl_Widget *w, void*) {
  Fl_Browser *ww = (Fl_Browser*)w;
  printf("BROWSER CALLBACK FOR %s: VALUE IS %d CHANGED=%d\n", ww->label(), ww->value(), ww->changed());
}

Fl_Tabs *tabs = 0;
Fl_Radio_Button *b1  = 0;
Fl_Radio_Button *b2  = 0;
Fl_Radio_Button *b3  = 0;
Fl_Light_Button *lb1 = 0;
Fl_Light_Button *lb2 = 0;
Fl_Hold_Browser *br  = 0;

static void ChoiceCallback(Fl_Widget *w, void*) {
  Fl_Choice *ww = (Fl_Choice*)w;
  const char *text = ww->text();
  if ( !text ) return;
  int when = 0;
  if (strcmp(text, "FL_WHEN_NEVER") == 0 ) {
    when = FL_WHEN_NEVER; 
  }
  if (strcmp(text, "FL_WHEN_CHANGED") == 0 ) {
    when = FL_WHEN_CHANGED;
  }
  if (strcmp(text, "FL_WHEN_CHANGED:FL_WHEN_RELEASE") == 0 ) {
   when = FL_WHEN_CHANGED|FL_WHEN_RELEASE;
  }
  if (strcmp(text, "FL_WHEN_CHANGED:FL_WHEN_RELEASE_ALWAYS") == 0 ) {
   when = FL_WHEN_CHANGED|FL_WHEN_RELEASE_ALWAYS;
  }
  if (strcmp(text, "FL_WHEN_NOT_CHANGED") == 0 ) {
   when = FL_WHEN_NOT_CHANGED;
  }
  if (strcmp(text, "FL_WHEN_NOT_CHANGED:FL_WHEN_CHANGED") == 0 ) {
   when = FL_WHEN_NOT_CHANGED|FL_WHEN_NOT_CHANGED;
  }
  if (strcmp(text, "FL_WHEN_RELEASE") == 0 ) {
   when = FL_WHEN_RELEASE;
  }
  if (strcmp(text, "FL_WHEN_RELEASE:FL_WHEN_NOT_CHANGED") == 0 ) {
   when = FL_WHEN_RELEASE|FL_WHEN_NOT_CHANGED;
  }
  if (strcmp(text, "FL_WHEN_RELEASE_ALWAYS") == 0 ) {
   when = FL_WHEN_RELEASE_ALWAYS;
  }
  if (strcmp(text, "FL_WHEN_RELEASE_ALWAYS:FL_WHEN_NOT_CHANGED") == 0 ) {
   when = FL_WHEN_RELEASE_ALWAYS|FL_WHEN_NOT_CHANGED;
  }
  if (strcmp(text, "FL_WHEN_ENTER_KEY") == 0 ) {
   when = FL_WHEN_RELEASE_ALWAYS|FL_WHEN_NOT_CHANGED;
  }
  if (strcmp(text, "FL_WHEN_ENTER_KEY_ALWAYS") == 0 ) {
   when = FL_WHEN_ENTER_KEY_ALWAYS;
  }
  if (strcmp(text, "FL_WHEN_ENTER_KEY_CHANGED") == 0 ) {
   when = FL_WHEN_ENTER_KEY_CHANGED;
  }
  // Apply when() value to all widgets
  tabs->when(when);
    b1->when(when);
    b2->when(when);
    b3->when(when);
    br->when(when);
   lb1->when(when);
   lb2->when(when);
}

int main(int argc, char *argv[]) {
    Fl_Window *win = new Fl_Window(500,450,"Test Fl_Tabs when() callback() vs. other widgets");
        /// TABS
        tabs = new Fl_Tabs(10,10,500-20,200-20);
	tabs->tooltip("Fl_Tabs widget");
	    Fl_Button *b;
	    Fl_Input *i;
            Fl_Group *aaa = new Fl_Group(10,35,500-20,200-45,"Aaa");
                b = new Fl_Button(100, 60,90,25,"Button A1"); b->color(FL_RED); b->tooltip(b->label());
                i = new Fl_Input( 100, 90,90,25,"Red Input 1"); i->tooltip(i->label());
                i = new Fl_Input( 100,120,90,25,"Red Input 2"); i->tooltip(i->label());
	    aaa->tooltip("Tab Aaa aaa aaa");
            aaa->end();
            Fl_Group *bbb = new Fl_Group(10,35,500-10,200-35,"Bbb");
                b = new Fl_Button( 100,60,90,25,"Button B1"); b->color(FL_GREEN); b->tooltip(b->label());
                i = new Fl_Input( 100, 90,90,25,"Grn Input 1"); i->tooltip(i->label());
                i = new Fl_Input( 100,120,90,25,"Grn Input 2"); i->tooltip(i->label());
            bbb->end();
	    bbb->tooltip("Tab Bbb bbb bbb");
            Fl_Group *ccc = new Fl_Group(10,35,500-10,200-35,"Ccc");
                b = new Fl_Button(100, 60,90,25,"Button C1"); b->color(FL_BLUE); b->tooltip(b->label());
                i = new Fl_Input( 100, 90,90,25,"Blu Input 1"); i->tooltip(i->label());
                i = new Fl_Input( 100,120,90,25,"Blu input 2"); i->tooltip(i->label());
            ccc->end();
	    ccc->tooltip("Tab Ccc ccc ccc");
        tabs->end();
	tabs->callback(TabsCallback);
	/// RADIO BUTTONS
        b1 = new Fl_Radio_Button(100,210+0,20,20,"Radio Aaa");
	b1->align(FL_ALIGN_LEFT);
	b1->callback(RadioCallback);
        b2 = new Fl_Radio_Button(100,210+25,20,20,"Radio Bbb");
	b2->callback(RadioCallback);
	b2->align(FL_ALIGN_LEFT);
        b3 = new Fl_Radio_Button(100,210+50,20,20,"Radio Ccc");
	b3->callback(RadioCallback);
	b3->align(FL_ALIGN_LEFT);
	/// BROWSER
        br = new Fl_Hold_Browser(290,210,200,70,"Browser");
	br->add("Aaa browser item #1");
	br->add("Bbb browser item #2");
	br->add("Ccc browser item #3");
	br->callback(BrowserCallback);
        /// LIGHT BUTTONS
        lb1 = new Fl_Light_Button(180,320,180,25, "Light Button 1");
	lb1->callback(LightCallback);
        lb2 = new Fl_Light_Button(180,350,180,25, "Light Button 2");
	lb2->callback(LightCallback);

	Fl_Choice *choice = new Fl_Choice(50,400,450,25,"when()");
        choice->add("FL_WHEN_NEVER");

        choice->add("FL_WHEN_CHANGED");
        choice->add("FL_WHEN_CHANGED:FL_WHEN_RELEASE");
        choice->add("FL_WHEN_CHANGED:FL_WHEN_RELEASE_ALWAYS");

        choice->add("FL_WHEN_NOT_CHANGED");
        choice->add("FL_WHEN_NOT_CHANGED:FL_WHEN_CHANGED");

        choice->add("FL_WHEN_RELEASE");
        choice->add("FL_WHEN_RELEASE:FL_WHEN_NOT_CHANGED");
        choice->add("FL_WHEN_RELEASE_ALWAYS");
        choice->add("FL_WHEN_RELEASE_ALWAYS:FL_WHEN_NOT_CHANGED");
        choice->add("FL_WHEN_ENTER_KEY");
        choice->add("FL_WHEN_ENTER_KEY_ALWAYS");
        choice->add("FL_WHEN_ENTER_KEY_CHANGED");
	choice->callback(ChoiceCallback);

    win->end();
    win->show();
    return(Fl::run());
}
